/*
*  Plugin is used to fix some bugs in MZ/FF drag processing
* 
*  Distributed under the terms of the GNU Library General Public License
*
*  @package ddi (Drag'n'Drop Interface)
*  @version 1.0
*  @title Fix MZ drag
*  @author Ilya Lebedev (ilya@lebedev.net), (c) 2005
*
*  Revision history
*
*  v1.0
*  + first public release
*/
__DDI__.plugin.fixDragInMz = new function () {
  this.name = 'Fix MZ/FF drag';
  this.description = "Plugin applies some bugfixes to MZ/FF drag processing";
  this.group = 'DDI_CORE';
  /*
  *  Tags list to check
  *
  *  @var object
  *  @access privat
  */
  var tags = {'a':true,'img':true};
  this.dragstart = {
    'after' : function (e) {
       if (e.preventDefault) {
         var oldPos = e.__currentTarget.style.position;
         var cs = document.defaultView.getComputedStyle(e.__currentTarget,'');
         switch (cs.position) {
           /*
           *  Fixing MZ/FF bug when it does not release event.target when dragging absolutely positioned node
           */
           case "absolute" : 
             e.__currentTarget.style.position='static';
             break;
           /*
           *  Fixing MZ/FF bug when it does not allow to drop nodes with position:static on DOM levels below
           *  element with position:relative
           */
           case "static" : 
           case "" : 
             e.__currentTarget.style.position='relative';
             break;
           }
         e.__currentTarget.style.position=oldPos;
         /*
         *  Fixing MZ/FF behaviour, prevents element dropping on lower-level DOM nodes
         */
         e.preventDefault();
       }
     }
  }
}
